﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Olap;
using System.Collections;
using Infragistics.Olap.FlatData;

namespace FromDataSet
{
    public class TopCountAggregator<T> :
        IAggregator<T, TopCountCache<T>>
    {
        public string Identity
        {
            get;
            set;
        }

        public IAggregationResult<T, TopCountCache<T>>
            Evaluate(IAggregationResult<T, TopCountCache<T>> oldResult,
                     IAggregateable aggregateable,
                     IEnumerable items)
        {
            var result = new TopCountResult<T>();
            foreach (DataRowMetadata  item in items)
            {
                var value = (T)aggregateable.GetValue(item);
                result.Cache.AddCount(value);
            }

            return result;
        }

        public IAggregationResult
            Evaluate(IAggregationResult oldResult,
                     IAggregateable aggregateable,
                     IEnumerable items)
        {
            IAggregationResult res = this.Evaluate((oldResult as TopCountResult<T>),
                aggregateable, items);
            return res;
        }

        public IAggregationResult<T, TopCountCache<T>>
            Evaluate(IAggregationResult<T, TopCountCache<T>> oldResult,
                     T value)
        {
            throw new NotImplementedException();
        }

        public IAggregationResult
            Evaluate(IAggregationResult oldResult, object value)
        {
            throw new NotImplementedException();
        }

      

    }

}
