﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FromDataSet
{
    public class TopCountCache<T>
    {
        private IDictionary<T, int> _itemsCache =
            new Dictionary<T, int>();

        public T TopItem
        {
            get
            {
                int maxValue =
                    this._itemsCache.Max(kvp => kvp.Value);
                return this._itemsCache
                    .Where(kvp => kvp.Value == maxValue).First().Key;
            }
        }

        public void AddCount(T item)
        {
            var value = item as ValueType;
            if (value == null && item == null)
            {
                return;
            }

            if (!this._itemsCache.ContainsKey(item))
            {
                this._itemsCache.Add(item, 1);
            }
            else
            {
                this._itemsCache[item]++;
            }
        }
    }
}
